//+-----------------------------------------------------------------+
//|                                              LevelTrades_v8.mq4 |
//+-----------------------------------------------------------------+
//| HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH |
//| H\    \               http://wsforex.ru/               /    / H |
//| H )----)----------------------------------------------(----(  H |
//| H/    /       : wsforex.ru   \    \ H |
//| HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH |
//+-----------------------------------------------------------------+

#property copyright "wsforex@list.ru"
#property link      "http://wsforex.ru/"
#property strict
#include <stdlib.mqh>
//+-----------------------------------------------------------------+
//|  : .  -   -  "http://wsforex.ru/"       |
//|      : TarasBY - 11.09.2014                               |
//+-----------------------------------------------------------------+
extern bool    TradeShort         = false;
extern bool    TradeLong          = false;
extern bool    Trade_Avtomat      = True;
extern int     PenetrationOpen    = 1;
extern int     PenBuyStopLoss     = 0;
extern int     PenSellStopLoss    = 0;
extern double  Lots               = 0.60;
extern int     Otstup             = 20;
extern int     SL                 = 25;
extern int     TP1                = 15; 
extern int     TP2                = 55; 
extern int     Slippage           = 5;
extern int     magic              = 66780;
extern bool    RemoveLinesOnExit  = True;
extern bool    Level_BU           = True;
extern bool    MM_LotProcent      = false;
extern double  Lot_Procent        = 30.;
extern double  Lots_Out           = 0.40;  
extern bool    Stealth_mode       = false;
extern bool    Timer              = True;
extern int     Delay              = 600;
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
extern color   OP_color           = LimeGreen;
extern int     OP_shirline        = 1;
extern color   SL_color           = Crimson;
extern int     SL_shirline        = 1;
extern color   TP1_color          = Orange;
extern int     TP1_shirline       = 1;
extern color   TP2_color          = OrangeRed;
extern int     TP2_shirline       = 2;
extern color   Txtclr             = DodgerBlue;
extern int     Smtxt              = 5;
extern int     FS                 = 8;
//+--------------------------------------------------------------------------------------------+
extern bool    UseSound           =  True;  // ------------------    |
extern string  Sound_buy          =  "news.wav";   // -----------    |
extern string  Sound_sell         =  "alert2.wav"; // -----------    |
extern string  Sound_stops        =  "stops.wav";  // -----------    |
extern string  Sound_close        =  "ok.wav";     // -----------    |
//+--------------------------------------------------------------------------------------------+
string Op_Long   = "TradeLong";
string Op_Short  = "TradeShort";
string SL_short  = "SLshort";
string SL_long   = "SLlong";
string TP_short1 = "TPshort1";
string TP_long1  = "TPlong1";
string TP_short2 = "TPshort2";
string TP_long2  = "TPlong2";    
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
double ldsls, ldslb, ldr, ldn, lbtp1, lbtp2, pb, pa, lstp1, lstp2, Oplong, Opshrot, po;
int    dg, kn, tn, res, SigShrot, SigLong;
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
int init()
{
// -----
    if (!IsExpertEnabled())
    {
        Alert ("!     "); 
        return (0);
    }
// -----
    if (Lots_Out > Lots)
    {
        Alert ("! Lots_Out    Lots"); 
        return (0);
    }
// -----
    for (int i = 3; i >= 0; i--)
    {
        bool ob = RefreshRates(); 
        if (ob) break; 
        Comment ("!     .");
        Sleep (3000);
    }
    Comment ("");
// -----
    StartLevels();
// -----
    if (Timer) 
    { 
        while (!IsStopped() && IsExpertEnabled())
        { 
            main();
            Sleep (Delay);
        }
    }
// -----
    return (0);
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void StartLevels()
{
    pb = MarketInfo (_Symbol, MODE_BID);
    pa = MarketInfo (_Symbol, MODE_ASK);
    dg = (int) MarketInfo (_Symbol, MODE_DIGITS);
// -----
    if (dg == 2 || dg == 3) po = 0.01;
    if (dg == 4|| dg == 5) po = 0.0001;
// -----
    if (Trade_Avtomat && TradeLong)
    {
        ObjectDelete (Op_Long);
        if (ObjectFind (Op_Long) < 0)
        {
            ObjectCreate (Op_Long, OBJ_HLINE, 0, TimeCurrent(), ND (pa + Otstup * po));
            ObjectSet (Op_Long, OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet (Op_Long, OBJPROP_WIDTH, OP_shirline); 
            ObjectSet (Op_Long, OBJPROP_COLOR, OP_color);
            ObjectSetText (Op_Long, "Op_Long", 10);
        } 
    }
// -----
    if (Trade_Avtomat && TradeShort)
    {
        ObjectDelete (Op_Short);
        if (ObjectFind (Op_Short) < 0)
        {
            ObjectCreate (Op_Short, OBJ_HLINE, 0, TimeCurrent(), ND (pb - Otstup * po));
            ObjectSet (Op_Short, OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet (Op_Short, OBJPROP_WIDTH, OP_shirline); 
            ObjectSet (Op_Short, OBJPROP_COLOR, OP_color);
            ObjectSetText (Op_Short, "Op_Short", 10);
        }
    }
    WindowRedraw();
// -----
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
int OpenPosicion()
 {   
// -----
    int  ticket;
    bool lb_result = false;
    pb = MarketInfo (_Symbol, MODE_BID);
    pa = MarketInfo (_Symbol, MODE_ASK);
    dg = (int) MarketInfo (_Symbol, MODE_DIGITS);
// -----
    double ld1 = ND (ObjectGet (Op_Short, OBJPROP_PRICE1)),
           ld3 = ND (ld1 - (PenetrationOpen * po)),
           ld2 = ND (ObjectGet (Op_Long , OBJPROP_PRICE1)),
           ld4 = ND (ld2 + (PenetrationOpen * po));
    RefreshRates();
    if (TradeLong && ld4 > 0. && pb >= ld4 && SigLong == 0 && openPositionsBau() <= 0 && (Low[2] < ld4 || Low[1] < ld4))
    {
        ticket = OrderSend (_Symbol, OP_BUY, Lots, ND (Ask), Slippage, 0, 0, "LinesTrades", magic, 0, Green);
        if (ticket < 0) {Print ("Error opening long order. Error :: ", ErrorDescription (GetLastError()));}
        else
        {
            if (ticket > 0 && !Stealth_mode)
            {
               if (OrderSelect (ticket, SELECT_BY_TICKET))
               {
                   while (!IsTradeAllowed()) Sleep(500);
                   lb_result = OrderModify (OrderTicket(), OrderOpenPrice(), ND (OrderOpenPrice() - SL * po), ND (OrderOpenPrice() + TP2 * po), 0, Red);
               }
            }
            if (UseSound) PlaySound (Sound_buy);
            SigLong++; 
        }
    }
    RefreshRates();
    if (TradeShort && ld3 > 0. && pb <= ld3 && SigShrot == 0 && openPositionsSell() <= 0 && (High[2] > ld3 || High[1] > ld3))
    {
        ticket = OrderSend (_Symbol, OP_SELL, Lots, ND (Bid), Slippage, 0, 0, "LinesTrades", magic, 0, Red);
        if (ticket < 0) {Print("Error opening short order. Error :: ", ErrorDescription (GetLastError()));}
        else
        {
            if (ticket > 0 && !Stealth_mode)
            {
                if (OrderSelect (ticket, SELECT_BY_TICKET))
                {
                    while (!IsTradeAllowed()) Sleep(500);
                    lb_result = OrderModify (OrderTicket(), OrderOpenPrice(), ND (OrderOpenPrice() + SL * po), ND (OrderOpenPrice() - TP2 * po), 0, Red);
                }
            }
            if (UseSound) PlaySound (Sound_sell);
            SigShrot++;    
        }
    }
    return (-1);
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void ClosePosicion()
{    
    int  CLbay = 0, CLsell = 0;
    bool lb_result = false;
    pb = MarketInfo (_Symbol, MODE_BID);
    pa = MarketInfo (_Symbol, MODE_ASK);
    if ((Low[1] <= lbtp2 || Low[0] <= lbtp2 ) && pb - PenBuyStopLoss * po >= lbtp2)  CLbay = 1;
    if ((High[1] >= ldslb || High[0] >= ldslb) && pa + PenBuyStopLoss * po <= ldslb)  CLbay = 1;
    if ((High[1] >= lstp2 || High[0] >= lstp2) && pa - PenSellStopLoss * po <= lstp2) CLsell = 1;
    if ((Low[1] <= ldsls || Low[0] <= ldsls ) && pb + PenSellStopLoss * po >= ldsls) CLsell = 1;
   
    int cnt = OrdersTotal();
    for (int i = cnt - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != _Symbol) continue;
        if (OrderMagicNumber() != magic) continue; 
        if (OrderType() == OP_BUY && CLbay == 1)
        {
            lb_result = OrderClose (OrderTicket(), NormalizeDouble (OrderLots(), 2), ND (Bid), Slippage);
            if (UseSound) PlaySound (Sound_close);
        }
        if (OrderType() == OP_SELL && CLsell == 1)
        { 
            lb_result = OrderClose (OrderTicket(), NormalizeDouble (OrderLots(), 2), ND (Ask), Slippage);
            if (UseSound) PlaySound (Sound_close);
        }
    }
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void ObectText()
  { 
// -----
    if (MM_LotProcent) Lots_Out = NormalizeDouble (Lots * Lot_Procent / 100.0, 2);
    lbtp1 = ND (ObjectGet (TP_long1, OBJPROP_PRICE1));
    lstp1 = ND (ObjectGet (TP_short1,OBJPROP_PRICE1));
    lbtp2 = ND (ObjectGet (TP_long2, OBJPROP_PRICE1));
    lstp2 = ND (ObjectGet (TP_short2,OBJPROP_PRICE1));
    ldslb = ND (ObjectGet (SL_long,   OBJPROP_PRICE1));
    ldsls = ND (ObjectGet (SL_short,  OBJPROP_PRICE1));
    Oplong = ND (ObjectGet (Op_Long ,OBJPROP_PRICE1));
    Opshrot = ND (ObjectGet (Op_Short,OBJPROP_PRICE1));
    double TicVal = MarketInfo (_Symbol, MODE_TICKVALUE) * 10.;
   //if(StringFind(Symbol(),"m")==6)TicVal=TicVal*10;
// -----
    int      i = 0, prof_pts = 0, ticket = 0; 
    double   lot = 0., point_pts, profb = 0., profs = 0., opbuy = 0., opsell = 0.,
             CP = 5. * po;
    datetime CT = Time[0] + _Period * 60 * (WindowBarsPerChart() / 30 + 2);
    color    prof_clr = Blue;
    string   txt = "";
    for (i = 0; i < 10; i++) DeleteLabels();
// -----
    int cnt = OrdersTotal();
    for (int j = cnt - 1; j >= 0; j--)
    {
        if (!OrderSelect (j, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != _Symbol) continue;
        if (OrderMagicNumber() != magic) continue;  
        if (OrderType() == OP_BUY)
        {
            opbuy = ND (OrderOpenPrice());
            profb = OrderProfit() + OrderCommission() + OrderSwap();
            prof_clr = Blue;
            if (profb < 0.) prof_clr = Red; else prof_clr = Green;
            ObjectCreate ("topen_bay", OBJ_TEXT, 0, CT, Oplong + CP);
            txt = "";
            txt = "" + DoubleToStr (MathAbs (profb), 2) + "$";
            ObjectSetText ("topen_bay", txt, FS, "Arial", prof_clr); 
// -----
            if (lbtp2 != 0.)
            {
                if (OrderLots() < Lots_Out) {lot = OrderLots();} else {lot = OrderLots() - Lots_Out;}
                point_pts = MathAbs (OrderOpenPrice() - lbtp2) / po; 
                txt = "" + DoubleToStr (point_pts * lot * TicVal, 2) + "$";
                ObjectCreate ("ttake_sell2", OBJ_TEXT, 0, CT, lbtp2 + CP);
                ObjectSetText ("ttake_sell2", txt, FS, "Arial", Green);
            }
// -----
            if (lbtp1 != 0.)
            {
                point_pts = MathAbs (OrderOpenPrice() - lbtp1) / po;
                txt = "" + DoubleToStr (point_pts * Lots_Out * TicVal, 2) + "$";
                ObjectCreate ("ttake_sell1", OBJ_TEXT, 0, CT, lbtp1 + CP);
                ObjectSetText ("ttake_sell1", txt, FS, "Arial", Green);
            }
// -----
            if (ldslb != 0.)
            {
                point_pts = MathAbs (OrderOpenPrice() - ldslb) / po;
                txt = "" + DoubleToStr (point_pts * OrderLots() * TicVal, 2) + "$";
                ObjectCreate ("tstop_sell", OBJ_TEXT, 0, CT, ldslb + CP);
                ObjectSetText ("tstop_sell", txt, FS, "Arial", Red);
            }
        }
// -----
        if (OrderType() == OP_SELL)
        {
            opsell = ND (OrderOpenPrice());
            profs = OrderProfit() + OrderCommission() + OrderSwap();
            prof_clr = Blue;
            if (profs < 0.) prof_clr = Red; else prof_clr = Green;
            ObjectCreate ("topen_sell", OBJ_TEXT, 0, CT, Opshrot + CP);
            txt = "";
            txt = "" + DoubleToStr (MathAbs (profs), 2) + "$";
            ObjectSetText ("topen_sell", txt, FS, "Arial", prof_clr);
// -----
            if (lstp2 != 0.)
            {
                if (OrderLots() < Lots_Out) {lot = OrderLots();} else {lot = OrderLots() - Lots_Out;}
                point_pts = MathAbs (OrderOpenPrice() - lstp2) / po;
                txt = "" + DoubleToStr (point_pts * lot * TicVal, 2) + "$";
                ObjectCreate ("ttake_bay2", OBJ_TEXT, 0, CT, lstp2 + CP);
                ObjectSetText ("ttake_bay2", txt, FS, "Arial", Green);
            }
// -----
            if (lstp1 != 0.)
            {
                point_pts = MathAbs (OrderOpenPrice() - lstp1) / po;       
                txt = "" + DoubleToStr (point_pts * Lots_Out * TicVal, 2) + "$";
                ObjectCreate ("ttake_bay1", OBJ_TEXT, 0, CT, lstp1 + CP);
                ObjectSetText ("ttake_bay1", txt, FS, "Arial", Green);
            }
// -----
            if (ldsls != 0.)
            {
                point_pts = MathAbs (OrderOpenPrice() - ldsls) / po;
                txt = "" + DoubleToStr (point_pts * OrderLots() * TicVal, 2) + "$";
                ObjectCreate ("tstop_bay", OBJ_TEXT, 0, CT, ldsls + CP);
                ObjectSetText ("tstop_bay", txt, FS, "Arial", Red);
            }
        }
        Lines (opbuy, opsell);
    }
// -----
    WindowRedraw(); 
// -----
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void HClosePosicion()
{  
    bool eer;
    RefreshRates();
    if (MM_LotProcent) Lots_Out = NormalizeDouble (Lots * Lot_Procent / 100.0, 2);
    lbtp1 = ND (ObjectGet (TP_long1, OBJPROP_PRICE1));
    lstp1 = ND (ObjectGet (TP_short1, OBJPROP_PRICE1));
    Comment (StringConcatenate (lstp1, "   ", lbtp1));
    int cnt = OrdersTotal();
    for (int i = cnt - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != _Symbol) continue;
        if (OrderMagicNumber() != magic) continue;
        if (OrderLots() != Lots) continue;
        if (OrderType() == OP_BUY)
        {
            if (ND (Bid) >= lbtp1 && (Low[1] < lbtp1 || Low[2] < lbtp1))
            {
                eer = OrderClose (OrderTicket(), NormalizeDouble (Lots_Out, 2), ND (Bid), Slippage);
                if (UseSound && eer) PlaySound (Sound_stops);
            }
        }
        if (OrderType() == OP_SELL)
        {
            if (ND (Ask) <= lstp1 && (High[1] > lstp1 || High[2] > lstp1))
            { 
                eer = OrderClose (OrderTicket(), NormalizeDouble (Lots_Out, 2), ND (Ask), Slippage);
                if (UseSound && eer) PlaySound (Sound_stops);
            }
        }
    }
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void UshetOrders()
{
    if (openPositionsSell() == 0) ObjectDeleteSELL();
    if (openPositionsBau() == 0) ObjectDeleteBAY();
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
int openPositionsSell()
{ 
    int op = 0;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != _Symbol) continue;
        if (OrderMagicNumber() != magic) continue;
        if (OrderType() == OP_SELL) op++; 
    } 
    return (op);
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
int openPositionsBau()
{  
    int op = 0;
    for (int i = OrdersTotal() - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != _Symbol) continue;
        if (OrderMagicNumber() != magic) continue;
        if (OrderType() == OP_BUY) op++; 
    } 
    return (op);
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void DeleteLabels()
{
    ObjectDelete ("topen_sell");
    ObjectDelete ("ttake_sell1");
    ObjectDelete ("ttake_sell2");
    ObjectDelete ("tstop_sell");
    ObjectDelete ("topen_bay");
    ObjectDelete ("ttake_bay1");
    ObjectDelete ("ttake_bay2");
    ObjectDelete ("tstop_bay");
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void Lines (double Opl, double Ops)
{     
    RefreshRates();
    if (ObjectFind (TP_short2) != 0)
    {
        if (ObjectFind (Op_Short) != -1)
        {  
            ObjectDelete (SL_short);
            if (ObjectFind (SL_short) < 0)
            {
                ObjectCreate (SL_short, OBJ_HLINE, 0, TimeCurrent(), ND (Ops + SL * po));
                ObjectSet (SL_short, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet (SL_short, OBJPROP_WIDTH, SL_shirline); 
                ObjectSet (SL_short, OBJPROP_COLOR, SL_color);
                ObjectSetText (SL_short, "SL_short", 10);
            } 
            if (Level_BU)
            {
                ObjectDelete (TP_short1);
                if (ObjectFind (TP_short1) < 0)
                {
                    ObjectCreate (TP_short1, OBJ_HLINE, 0, TimeCurrent(), ND (Ops - TP1 * po));
                    ObjectSet (TP_short1, OBJPROP_STYLE, STYLE_SOLID);
                    ObjectSet (TP_short1, OBJPROP_WIDTH, TP1_shirline); 
                    ObjectSet (TP_short1, OBJPROP_COLOR, TP1_color);
                    ObjectSetText (TP_short1, "TP_short1", 10);
                } 
            }
            ObjectDelete (TP_short2);
            if (ObjectFind (TP_short2) < 0)
            {
                ObjectCreate (TP_short2, OBJ_HLINE, 0, TimeCurrent(), ND (Ops - TP2 * po));
                ObjectSet (TP_short2, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet (TP_short2, OBJPROP_WIDTH, TP2_shirline); 
                ObjectSet (TP_short2, OBJPROP_COLOR, TP2_color);
                ObjectSetText (TP_short2, "TP_short2", 10);
            }
        }
    }    
    RefreshRates();
    if (ObjectFind (TP_long2) != 0)
    {
        if (ObjectFind(Op_Long) != -1)
        {
            ObjectDelete (SL_long);
            if (ObjectFind (SL_long) < 0)
            {
                ObjectCreate (SL_long, OBJ_HLINE, 0, TimeCurrent(), ND (Opl - SL * po));
                ObjectSet (SL_long, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet (SL_long, OBJPROP_WIDTH, SL_shirline); 
                ObjectSet (SL_long, OBJPROP_COLOR, SL_color);
                ObjectSetText (SL_long, "SL_long", 10);
            } 
            if (Level_BU)
            {
                ObjectDelete (TP_long1);  
                if (ObjectFind (TP_long1) < 0)
                {
                    ObjectCreate (TP_long1, OBJ_HLINE, 0, TimeCurrent(), ND (Opl + TP1 * po));
                    ObjectSet (TP_long1, OBJPROP_STYLE, STYLE_SOLID);
                    ObjectSet (TP_long1, OBJPROP_WIDTH, TP1_shirline); 
                    ObjectSet (TP_long1, OBJPROP_COLOR, TP1_color);
                    ObjectSetText (TP_long1, "TP_long1", 10);
                } 
            }
            ObjectDelete (TP_long2);
            if (ObjectFind (TP_long2) < 0)
            {
                ObjectCreate (TP_long2, OBJ_HLINE, 0, TimeCurrent(), ND (Opl + TP2 * po));
                ObjectSet (TP_long2, OBJPROP_STYLE, STYLE_SOLID);
                ObjectSet (TP_long2, OBJPROP_WIDTH, TP2_shirline);
                ObjectSet (TP_long2, OBJPROP_COLOR, TP2_color);
                ObjectSetText (TP_long2, "TP_long2", 10);
            } 
        }    
    }
    WindowRedraw();
}   
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void deinit()
{   
    if (RemoveLinesOnExit) 
    {
        ObjectDelete (Op_Short);
        ObjectDelete (Op_Long);
        ObjectDeleteSELL();
        ObjectDeleteBAY(); 
    }
    DeleteLabels();
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void OrdersModificator()
{
    double tp_b = ND (ObjectGet (TP_long2, OBJPROP_PRICE1)),
           tp_s = ND (ObjectGet (TP_short2, OBJPROP_PRICE1)),
           sl_b = ND (ObjectGet (SL_long, OBJPROP_PRICE1)),
           sl_s = ND (ObjectGet (SL_short, OBJPROP_PRICE1)),
           op_s = ND (ObjectGet (Op_Short, OBJPROP_PRICE1)),
           op_b = ND (ObjectGet (Op_Long, OBJPROP_PRICE1));
    int    cnt = OrdersTotal();
    bool   lb_result = false;
    for (int i = cnt - 1; i >= 0; i--)
    {
        if (!OrderSelect (i, SELECT_BY_POS, MODE_TRADES)) continue;
        if (OrderSymbol() != _Symbol) continue;
        if (OrderMagicNumber() != magic) continue;
        if (OrderType() == OP_BUY)
        {
            if (ND (op_b) != ND (OrderOpenPrice()))
            { 
                ObjectSet (Op_Long, OBJ_HLINE, ND (OrderOpenPrice()));
                ObjectSet (Op_Long, OBJPROP_STYLE, STYLE_DOT);
                ObjectSet (Op_Long, OBJPROP_WIDTH, 1); 
                ObjectSet (Op_Long, OBJPROP_COLOR, DodgerBlue);
            }         
            if (ND (tp_b) != ND (OrderTakeProfit()) && ND (OrderTakeProfit()) > ND (OrderOpenPrice()) && OrderTakeProfit() > 0. && tp_b > 0.)
            {lb_result = OrderModify (OrderTicket(), OrderOpenPrice(), OrderStopLoss(), ND (tp_b), 0, CLR_NONE);}
            if (ND(OrderStopLoss()) < ND(OrderOpenPrice()) &&  ND (sl_b) != ND (OrderStopLoss()) && OrderStopLoss() > 0. && sl_b > 0.)
            {lb_result = OrderModify (OrderTicket(), ND (OrderOpenPrice()), ND (sl_b), ND (OrderTakeProfit()), 0, CLR_NONE);}
        }
// ------   
        if (OrderType() == OP_SELL)
        { 
            if (ND (op_s) != ND (OrderOpenPrice()))
            { 
                ObjectSet (Op_Short, OBJ_HLINE, ND (OrderOpenPrice()));
                ObjectSet (Op_Short, OBJPROP_STYLE, STYLE_DOT);
                ObjectSet (Op_Short, OBJPROP_WIDTH, 1); 
                ObjectSet (Op_Short, OBJPROP_COLOR, DodgerBlue);
            }
            if (ND (tp_s) != ND (OrderTakeProfit()) && ND (OrderTakeProfit()) < ND (OrderOpenPrice()) && OrderTakeProfit() > 0. && tp_s > 0.)
            {lb_result = OrderModify (OrderTicket(), ND (OrderOpenPrice()), ND (OrderStopLoss()), ND (tp_s), 0, CLR_NONE);}
            if (ND (OrderStopLoss()) > ND (OrderOpenPrice()) && ND (sl_s) != ND (OrderStopLoss()) && OrderStopLoss() > 0. && sl_s > 0.)
            {lb_result = OrderModify (OrderTicket(), ND (OrderOpenPrice()), ND (sl_s), ND (OrderTakeProfit()), 0, CLR_NONE);}
        }
    }   
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void start()
{
 // ------
    main();
 // ------
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void  main()
{ 
// ------
    if (ObjectFind (Op_Short) != 0 && ObjectFind (Op_Long) != 0 && openPositionsBau() == 0 && openPositionsSell() == 0)
    {
        SigShrot = 0;
        SigLong = 0;
        StartLevels();
    }
// ------
    HClosePosicion(); 
    OrdersModificator(); 
    ObectText();
    UshetOrders(); 
    ClosePosicion(); 
    OpenPosicion();
// ------
}                           
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
void ObjectDeleteSELL()
{
    ObjectDelete (SL_short); 
    ObjectDelete (TP_short1); 
    ObjectDelete (TP_short2);
    ObjectDelete ("take_sell1");
    ObjectDelete ("take_sell2");
    ObjectDelete ("stop_sell");
    ObjectDelete ("stop_real.s");
}
void ObjectDeleteBAY()
{
   ObjectDelete (SL_long);
   ObjectDelete (TP_long1);
   ObjectDelete (TP_long2);
   ObjectDelete ("take_bay1");
   ObjectDelete ("take_bay2");
   ObjectDelete ("stop_bay");
   ObjectDelete ("stop_real.b");
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+
double ND (double np)
{
    double pp, ts = MarketInfo (_Symbol, MODE_TICKSIZE);
    int    di = (int) MarketInfo (_Symbol, MODE_DIGITS);
    if (ts > 0.) pp = NormalizeDouble (np / ts, 0) * ts;
    else {if (di > 0) pp = NormalizeDouble (np * di, 0) / di; else pp = np;}
    return (pp);
}
//+------------------------------------------------------------------------------+
//|        :    -   -  "http://wsforex.ru/"                    |
//+------------------------------------------------------------------------------+